summaryrefslogtreecommitdiffstats
diff options
context:
space:
mode:
author Yth - Arnaud <yth@ythogtha.org>2023-03-17 09:40:50 +0100
committer Willy Sudiarto Raharjo <willysr@slackbuilds.org>2023-03-18 09:50:18 +0700
commit334ea335780f5e6bd9358c22f4042fdb7b41b87c (patch)
tree88abdc585c6c7a9e42c8482611900088a04b8ff5
parent18dda33f5af77ba056fe659aee939819db926e3a (diff)
downloadslackbuilds-334ea335780f5e6bd9358c22f4042fdb7b41b87c.tar.gz
slackbuilds-334ea335780f5e6bd9358c22f4042fdb7b41b87c.tar.xz
python/PyPy: Added (implementation of Python 2 written in Python).
Signed-off-by: Matteo Bernardini <ponce@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
-rw-r--r--python/PyPy/PyPy.SlackBuild120
-rw-r--r--python/PyPy/PyPy.info10
-rw-r--r--python/PyPy/README21
-rw-r--r--python/PyPy/slack-desc19
4 files changed, 170 insertions, 0 deletions
diff --git a/python/PyPy/PyPy.SlackBuild b/python/PyPy/PyPy.SlackBuild
new file mode 100644
index 0000000000..de46dc8645
--- /dev/null
+++ b/python/PyPy/PyPy.SlackBuild
@@ -0,0 +1,120 @@
+#!/bin/bash
+
+# SlackBuild script for PyPy
+# Yth | Pont-en-Royans, France | yth@ythogtha.org
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=PyPy
+VERSION=${VERSION:-7.3.11}
+SRCNAM=pypy2.7
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i686 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "x86_64" ]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+rm -rf $SRCNAM-v$VERSION-src
+tar xvf $CWD/$SRCNAM-v$VERSION-src.tar.bz2
+cd $SRCNAM-v$VERSION-src
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p SBo
+# First step : translation and build
+PYCMD=$(which pypy2 2>/dev/null || which pypy 2>/dev/null || which python2)
+cd pypy/goal/
+$PYCMD ../../rpython/bin/rpython -Ojit targetpypystandalone
+
+# Second step : packaging by PyPy
+cd ../tool/release/
+python package.py --builddir ../../../SBo --archive-name $PRGNAM-$VERSION
+
+# Third step : repackaging in the pypy3 style
+cd ../../../SBo/$PRGNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p $PKG/usr/lib${LIBDIRSUFFIX}/$PRGNAM-$VERSION
+cp -a * $PKG/usr/lib${LIBDIRSUFFIX}/$PRGNAM-$VERSION
+
+# Create symlinks to pypy executables.
+mkdir -p $PKG/usr/bin
+( cd $PKG/usr/bin
+ ln -sf ../lib${LIBDIRSUFFIX}/$PRGNAM-$VERSION/bin/pypy pypy
+ ln -sf ../lib${LIBDIRSUFFIX}/$PRGNAM-$VERSION/bin/pypy2 pypy2
+ ln -sf ../lib${LIBDIRSUFFIX}/$PRGNAM-$VERSION/bin/pypy2.7 pypy2.7
+)
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a LICENSE README.rst $PKG/usr/doc/$PRGNAM-$VERSION
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/python/PyPy/PyPy.info b/python/PyPy/PyPy.info
new file mode 100644
index 0000000000..089bd1db74
--- /dev/null
+++ b/python/PyPy/PyPy.info
@@ -0,0 +1,10 @@
+PRGNAM="PyPy"
+VERSION="7.3.11"
+HOMEPAGE="https://www.pypy.org/"
+DOWNLOAD="https://downloads.python.org/pypy/pypy2.7-v7.3.11-src.tar.bz2"
+MD5SUM="249ad8b0ddffbb16a9d416c3ae85dd2c"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="pycparser %README%"
+MAINTAINER="Yth - Arnaud"
+EMAIL="yth@ythogtha.org"
diff --git a/python/PyPy/README b/python/PyPy/README
new file mode 100644
index 0000000000..78e6bd3909
--- /dev/null
+++ b/python/PyPy/README
@@ -0,0 +1,21 @@
+PyPy is a very compliant implementation of the Python language. PyPy
+has several advantages and distinctive features: speed (Just-in-Time
+compiler), lower memory usage for large programs, sandboxing and
+stackless mode.
+
+This script is for PyPy implementation of Python 2.7 from sources.
+Beware: this takes up a lot of time and about 5Gb of RAM in a 64bit
+system. And still 3Gb on a 32bit system.
+
+Note: This package does conflict with pypy, overwriting files.
+
+OPTIONAL: pypy or PyPy, available on SBo.
+If pypy2 is installed, from binary repackaging using pypy, or from
+a previous installation of PyPy, it'll be used instead of CPython2.7,
+as it is twice as fast.
+It might even be better for a first build of PyPy to build and install
+pypy first.
+pycparser is required only when using Slackware's CPython2.7
+for building.
+
+REQUIRES: you need one of pycparser, pypy or PyPy.
diff --git a/python/PyPy/slack-desc b/python/PyPy/slack-desc
new file mode 100644
index 0000000000..9ff0b3e921
--- /dev/null
+++ b/python/PyPy/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+PyPy: PyPy (implementation of Python 2 written in Python)
+PyPy:
+PyPy: PyPy is a very compliant implementation of the Python language. PyPy
+PyPy: has several advantages and distinctive features: speed (Just-in-Time
+PyPy: compiler), lower memory usage for large programs, sandboxing and
+PyPy: stackless mode.
+PyPy:
+PyPy: Homepage: http://pypy.org/
+PyPy:
+PyPy:
+PyPy: